entities = {}
fishes = {love.graphics.newImage("fish.jpeg")}
function entities:spawn()
	if math.random(1,100) == 1 then
		local fish = fishes[math.random(1,#fishes)]
		table.insert(self.fish,{image = fish,
			x = (function() if player.xvel <= 0 then return player.x - 1000 else return player.x + 1000 end end)(),
			y = math.random(1,love.graphics.getHeight() - fish:getHeight()),
			scale = 1/math.random(5,10),
			xvel = math.random(-1,1) * math.random(70,100),
			yvel = math.random(-1,1) * math.random(70,100),
			friction = 0.6
		})
	end
end

function entities.load(self)
	self.coral = { }
	self.fish  = { }
	local randomScale = 1/math.random(3,10)
	local i = 1
	local x = -10000
	local coralImage = love.graphics.newImage("coral1.jpeg")
	while x < 10000 do
		self.coral[i] = {
			image = coralImage,
			x = x,
			y = love.graphics.getHeight() - (coralImage:getHeight() * randomScale),
			scale = randomScale
		}
		x = x + (self.coral[i].image:getWidth() * randomScale) + (math.random(-1,1) * math.random(1,40))
		i = i + 1
		randomImage = math.random(1,1)
		randomScale = 1/math.random(3,10)
	end
	for i=1,5 do
		local fish = fishes[math.random(1,#fishes)]
		table.insert(self.fish,{image = fish,
			x = math.random(1,love.graphics.getWidth() - fish:getWidth()),
			y = math.random(1,love.graphics.getHeight() - fish:getHeight()),
			scale = 1/math.random(5,10),
			xvel = math.random(-1,1) * math.random(70,120),
			yvel = math.random(-1,1) * math.random(70,120),
			friction = 0.6
		})
	end
end

function entities:draw()
	for _,v in pairs(self.coral) do
		love.graphics.draw(v.image,v.x,v.y,0,v.scale,v.scale)
	end
	for _,v in pairs(self.fish) do
		love.graphics.draw(v.image,v.x,v.y,0,v.scale,v.scale)
	end
end

function entities:move(xvel, dt)
	for _,v in pairs(self.coral) do
		v.x = v.x - xvel * dt
	end
	for _,v in pairs(self.fish) do
		v.x = v.x - xvel * dt
		v.x = v.x + v.xvel * dt
		v.y = v.y + v.yvel * dt
		if v.y < 0 then
			v.y = 0 
			v.yvel = -v.yvel
		elseif v.y + (v.image:getHeight() * v.scale) > love.graphics.getHeight() then
			v.y = love.graphics.getHeight() - (v.image:getHeight() * v.scale)
			v.yvel = -v.yvel
		end
	end
end

function entities:checkCollision()
	for k,v in pairs(self.fish) do
		if player:collidiesWith(v) then
			if v.scale <= player.scale then
				table.remove(self.fish,k)
				player.scale = player.scale + 0.1
			else
				isDead = true
			end
		end
	end
end

local updaterate = 40
function entities:update(dt)
	self:checkCollision()
	for _,v in pairs(self.fish) do
		if math.random(1,updaterate) == 1 then
			v.xvel = math.random(-1,1) * math.random(70,100)
		end
		if math.random(1,updaterate) == 1 then
			v.yvel = math.random(-1,1) * math.random(70,100)
		end
		v.xvel = v.xvel * (1 - math.min(dt * v.friction,1))
		v.yvel = v.yvel * (1 - math.min(dt * v.friction,1))
	end
	self:spawn()
	--To limit the number of fish
	if #self.fish > 20 then
		local fishNum = math.random(1,#self.fish)
		local fish = self.fish[fishNum]
		if fish.x < 0 and fish.x > love.graphics.getWidth() then
			table.remove(self.fish,fishNum)
		end
	end
end





